=begin
#SendinBlue API

#SendinBlue provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/sendinblue  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  | 

OpenAPI spec version: 3.0.0
Contact: contact@sendinblue.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.19

=end

require 'date'

module SibApiV3Sdk
  class GetSmsCampaignStats
    # Number of delivered SMS
    attr_accessor :delivered

    # Number of sent SMS
    attr_accessor :sent

    # Number of processing SMS
    attr_accessor :processing

    # Number of softbounced SMS
    attr_accessor :soft_bounces

    # Number of hardbounced SMS
    attr_accessor :hard_bounces

    # Number of unsubscription SMS
    attr_accessor :unsubscriptions

    # Number of replies to the SMS
    attr_accessor :answered

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'delivered' => :'delivered',
        :'sent' => :'sent',
        :'processing' => :'processing',
        :'soft_bounces' => :'softBounces',
        :'hard_bounces' => :'hardBounces',
        :'unsubscriptions' => :'unsubscriptions',
        :'answered' => :'answered'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'delivered' => :'Integer',
        :'sent' => :'Integer',
        :'processing' => :'Integer',
        :'soft_bounces' => :'Integer',
        :'hard_bounces' => :'Integer',
        :'unsubscriptions' => :'Integer',
        :'answered' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'delivered')
        self.delivered = attributes[:'delivered']
      end

      if attributes.has_key?(:'sent')
        self.sent = attributes[:'sent']
      end

      if attributes.has_key?(:'processing')
        self.processing = attributes[:'processing']
      end

      if attributes.has_key?(:'softBounces')
        self.soft_bounces = attributes[:'softBounces']
      end

      if attributes.has_key?(:'hardBounces')
        self.hard_bounces = attributes[:'hardBounces']
      end

      if attributes.has_key?(:'unsubscriptions')
        self.unsubscriptions = attributes[:'unsubscriptions']
      end

      if attributes.has_key?(:'answered')
        self.answered = attributes[:'answered']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @delivered.nil?
        invalid_properties.push('invalid value for "delivered", delivered cannot be nil.')
      end

      if @sent.nil?
        invalid_properties.push('invalid value for "sent", sent cannot be nil.')
      end

      if @processing.nil?
        invalid_properties.push('invalid value for "processing", processing cannot be nil.')
      end

      if @soft_bounces.nil?
        invalid_properties.push('invalid value for "soft_bounces", soft_bounces cannot be nil.')
      end

      if @hard_bounces.nil?
        invalid_properties.push('invalid value for "hard_bounces", hard_bounces cannot be nil.')
      end

      if @unsubscriptions.nil?
        invalid_properties.push('invalid value for "unsubscriptions", unsubscriptions cannot be nil.')
      end

      if @answered.nil?
        invalid_properties.push('invalid value for "answered", answered cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @delivered.nil?
      return false if @sent.nil?
      return false if @processing.nil?
      return false if @soft_bounces.nil?
      return false if @hard_bounces.nil?
      return false if @unsubscriptions.nil?
      return false if @answered.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          delivered == o.delivered &&
          sent == o.sent &&
          processing == o.processing &&
          soft_bounces == o.soft_bounces &&
          hard_bounces == o.hard_bounces &&
          unsubscriptions == o.unsubscriptions &&
          answered == o.answered
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [delivered, sent, processing, soft_bounces, hard_bounces, unsubscriptions, answered].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SibApiV3Sdk.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
